<?php

/**
 * recibo_solicitud_up actions.
 *
 * @package    canon
 * @subpackage recibo_solicitud_up
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class recibo_solicitud_upActions extends sfQuery {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

              $conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $conn->beginTransaction();
        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }

            /*
             * variables de filtro
             */

            $whereModulo = ' ';
            if (isset($request['id_modulo'])) {
                $whereModulo = " AND tab1.id_modulo = '" . $request['id_modulo'] . "' ";
            }

            $parametros = '';
            if (isset($request['param'])) {
                $parametros =  $request['param'];
            }

             $id_plan_not = '';
            if (isset($request['id_plan_not'])) {
                $id_plan_not = "'" . $request['id_plan_not'] . "' ";
            }
            
            if ($parametros == ''||$id_plan_not == '') {
                throw new Exception("Los parametros obligatorios no fueron enviados");
                exit();
            }

        


            $parametros = explode("*", $parametros);
            $this->logMessage($parametros[0]. count($parametros));

            for ($i = 0; $i < count($parametros); $i=$i+1) {
                $regActual = explode("-", $parametros[$i]);
              
                $id = $regActual[0];
                $this->logMessage($id);
                $valor = $regActual[1];


                $sql = <<<EOD

      
UPDATE CA_RECIBO_SOLICITUD
SET valor                 =$valor
WHERE ID_RECIBO_SOLICITUD = $id


EOD;

                //ejecuta y obtiene el resultado del sql
                $conn->execute($sql);
            }

            $conn->commit();



            //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
            $id_ope_bd = 1;
            //obtener id maestro tabla
            $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_recibo_solicitud');
            //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
            $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd, "Liquidacion de la primera anualidad por notificaciones");

       $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
      
select tab0.*, tab1.valor_mensual, tab2.formula, 1 as anualidad 
from ca_recibo_solicitud tab0 
join ca_smdlv tab1 on tab0.id_smdlv=tab1.id_smdlv
join ca_formula tab2 on tab0.id_etapa=tab2.id_etapa and tab0.id_norma=tab2.id_norma
join ca_det_plan_not tab3 on tab0.id_det_plan_not=tab3.id_det_plan_not
join ca_plan_not tab4 on tab3.id_plan_not=tab4.id_plan_not

where tab4.id_plan_not=$id_plan_not

                        
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

            //ejecuta y obtiene el resultado del sql
            $recs = CN_TABLE::executeSQL($sql);

            $cant = count($recs);
            
            
            $this->totalRows = $cant;
            $this->startRow = $rowStart;
            $this->endRow = $rowEnd;
            $this->status = 0;
            $this->list_data = $recs;
            $this->logMessage("[RECIBO_SOLICITUD_UP] Consulta exitosa.");
        } catch (Exception $e) {


            $conn->rollback();

            $error = "[RECIBO_SOLICITUD_UP] ERROR: " . $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }
      // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
